/*
 Copyright (C) 2002 Andreas Thiede ( a.thiede@berlin.de )

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#if ! defined _XTV_IO_OUTPUT_HPP
#define _XTV_IO_OUTPUT_HPP

/*
 *  Audio.h
 *  xtv
 *
 *  Created by andi on Wed Oct 10 2001.
 *
 */

#include <IO/Manager/IONode.hpp>
#include <IO/Manager/IOBufferList.hpp>

/* forward */ class IOBuffer;

class IOOutput : public IONode {

    public:

        IOOutput( const string & aName, IODeviceID anID );
    
        virtual ~IOOutput();

        virtual bool attachTo  ( IOStream *,  bool start = true  );
        virtual bool detachFromStream();
    
        virtual bool updateFrom( IOBuffer * ioBuf );

        virtual size_t frameSize() = 0;

        virtual IOBuffer * getBuffer( int millisec = -1 );
    
        virtual size_t bufferCount();
        
    protected:

        IOBufferList  * mBuffers;
    
        void init();
        void finit();
    
};

#endif // _XTV_IO_OUTPUT_HPP